/*
 * IV Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 1-2.XII.2005
 *
 * Program wzorcowy do zadania C - Autobus
 *
 * Autor programu: Wojciech Mruczkiewicz
 */

#include <cstdio>
#include <queue>
using namespace std;

struct space {
	space(int x, int w) : l(x), r(w) { };
	space() { };
	bool operator < (const space & s) const {
		int a = (r - l);
		int b = (s.r - s.l);

		if (a / 2 == b / 2)
			return l > s.l;

		return a / 2 < b / 2;
	}
	int l;
	int r;
};

int n, l, r;

int add(priority_queue<space> & Q) {
	int ld = l - 1;
	int rd = n - r - 1;
	int xd = -2;

	if (!Q.empty())
		xd = (Q.top().r - Q.top().l) / 2;

	if (rd > xd && rd > ld) {
		if (r + 1 <= n - 1)
			Q.push(space(r + 1, n-1));
		r = n;
		return r - 1;
	} else if (xd >= rd && xd > ld) {
		space s = Q.top(); Q.pop();

		if (s.l <= s.l + xd -1) {
			Q.push(space(s.l, s.l + xd - 1));
		}
		if (s.l + xd + 1 <= s.r) {
			Q.push(space(s.l + xd + 1, s.r));
		}
		return s.l + xd - 1;
	} else { // ld >= rd && ld >= x
		if (2 <= l)
			Q.push(space(2, l));
		l = 0;
		return l;
	}

	return 0;
}

int main() {
	int t;
	scanf("%d", &t);

	while (t--) {
		int x, y, z, nz, m;
		priority_queue<space> Q;

		scanf("%d%d", &n, &m);
		scanf("%d%d", &x, &y);

		l = x - 1;
		r = x;
		z = 1;

		for (int i = 0; i < y; i++) {
			scanf("%d", &nz);

			for (; z < nz; z++)
				x = add(Q) + 1;

			if (i)
				printf(" ");
			printf("%d", x);

			z = nz;
		}
		printf("\n");
	}

	return 0;
}

